package com.gct.tools.etlcamelhuge.routeconfig;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.common.util.SGTUtil;
import com.gct.tools.etlcamelhuge.entity.ZDJG_WELL;
import com.gct.tools.etlcamelhuge.util.CALUtil;
import com.gct.tools.etlcamelhuge.util.TransUtil;
import org.apache.camel.Message;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.model.dataformat.JsonLibrary;
import org.apache.commons.lang3.ArrayUtils;
import org.eclipse.jetty.util.ArrayUtil;
import org.springframework.context.annotation.Configuration;

import java.io.*;
import java.math.BigDecimal;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;


@Configuration
public class CamelRestConfiguration extends RouteBuilder {


    public String gtTransUtil(String gtdata)//处理示功图
    {
        String gt = "";
        if (gtdata == null){
            gtdata = "";
        }

        Double[][] doubles = null;
        int len = gtdata.length()/8;
        if(!gtdata.equals(""))
        {
            for(int i=0;i<len;i++)
            {
                gt += String.valueOf(Double.parseDouble(gtdata.substring(i*8, i*8+3))/100)+ ",";
                if (i ==len-1){
                    gt += String.valueOf(Double.parseDouble(gtdata.substring(i*8+3, i*8+8))/100);
                }else {
                    gt += String.valueOf(Double.parseDouble(gtdata.substring(i*8+3, i*8+8))/100)+",";
                }
            }

            String[] s = gt.split(",");
            String w = "";
            for (int i = 0; i < s.length; i++) {
                w += new BigDecimal(Math.round(Double.parseDouble(s[i]) * 100)).stripTrailingZeros().toPlainString() + ",";
            }
            doubles = SGTUtil.encodeToDoubleArray(w);

        }
        String string = SGTUtil.encodeToString(doubles);
        return string;
    }
    public static String getDate()
    {
        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");//设置日期格式
        String date = df.format(new java.util.Date());// new Date()为获取当前系统时间
        return date;
    }


    public ZDJG_WELL loadGtData(String param, String well_id, String sysDate) throws Exception {
//        String date = getDate();

        URL restURL = new URL("http://11.72.128.71/api-service/tsdb/getLast?appKey=SR5vY4bED7");

        //此处的urlConnection对象实际上是根据URL的请求协议(此处是http) 生成的URLConnection类 的子类HttpURLConnection
        HttpURLConnection conn = (HttpURLConnection) restURL.openConnection();

        //请求方式
        conn.setRequestMethod("POST");

        //设置是否从httpUrlConnection读入，默认情况下是true; httpUrlConnection.setDoInput(true);
        conn.setDoOutput(true);

        //allowUserInteraction 如果为 true，则在允许用户交互（例如弹出一个验证对话框）的上下文中对此 URL 进行检查。
        conn.setAllowUserInteraction(false);
        DataOutputStream out = new DataOutputStream(conn
                .getOutputStream());
        String content = "id=" + URLEncoder.encode(param, "UTF-8");
        out.writeBytes(content);
        out.flush();
        out.close();
        PrintStream ps = new PrintStream(conn.getOutputStream());

        ps.close();

        InputStream is = null;
        if (conn.getResponseCode() == 200){
            is = conn.getInputStream();
        }else {
            is= conn.getErrorStream();
        }
        BufferedReader bReader = new BufferedReader(new InputStreamReader(is,"UTF-8"));
        String line, resultStr = "";
        while (null != (line = bReader.readLine())) {
            resultStr += line;
        }

        ZDJG_WELL z = new ZDJG_WELL();
        JSONObject json = null;
        try {
            json = JSONObject.parseObject(resultStr);

            if(json.size()>0){
                String value = json.get("value").toString();
                String time = json.get("time").toString();
                time= time.replace("Z", " UTC"); //2019-06-27T16:00:00.000 UTC
                SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS Z");//转换时区格式
                Date cjDate = format1 .parse(time) ;
                SimpleDateFormat fomat2 = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                SimpleDateFormat fomat3 = new SimpleDateFormat("yyyy-MM-dd HH:mm");
                String mydate = fomat2.format(cjDate);
                JSONObject json2= JSONObject.parseObject(value);
                String bool = json2.getString("state").toString();
                z.setIs_device_close(bool.equals("true")? "在线": "不在线");
                z.setIs_well_close("关井");
                if (!bool.equals("false")){
                    String data = json2.get("data").toString();
                    JSONObject jsonObject = JSONObject.parseObject(data);
//                    String offset = jsonObject.getString("offset");
                    String jh = well_id.replace(" ", "");
                    z.setWell_common_name(jh);
                    String gtsj = TransUtil.trans(jsonObject.getString("offset"),jsonObject.getString("load"));
                    Date timeRtu = null;
                    String  rtutime = jsonObject.getString("time");
                    timeRtu = fomat3.parse("0000-00-00 00:".equals(rtutime)? "2021-04-10 10:10": rtutime);
                    Date yunpingtai = fomat2.parse(mydate);
                    long time1 = timeRtu.getTime();
                    long time2 = yunpingtai.getTime();
                    Date date = new Date();
                    long time3 = date.getTime();
                    int hours1 = (int) ((time3 - time2) / (1000 * 60 * 60));
                    int hours = (int) ((time2 - time1) / (1000 * 60 * 60));
                    //云平台和采集时间相差要小于4小时
                    if (hours <4 && !"".equals(gtsj) && hours1< 4 ){
                        z.setZd_init_sgt(gtsj);//位移载荷点
//                        z.setProd_date(mydate);
//                        z.setSys_date(sysDate);
//                        z.setIs_well_close(Double.valueOf(jsonObject.getString("minCurrent")) > 0 ? "开井": "关井");
//                        z.setPressure(0);
                        if (jsonObject.getString("strokeFrequency") != null){
                            z.setStroke(CALUtil.round((Double.valueOf(jsonObject.getString("strokeFrequency"))) * 100) / 100);//冲程，但GTSB_2的冲程是CC字段
                        }
                        if (jsonObject.getString("stroke") != null){
                            z.setFrequence(CALUtil.round((Double.valueOf(jsonObject.getString("stroke"))) * 100) / 100);//冲次，但GTSB_2的冲次是PJXC字段
                        }
                        z.setSxzh(Double.parseDouble(jsonObject.getString("maxLoad")));//最大载荷
                        z.setXxzh(Double.parseDouble(jsonObject.getString("minLoad")));//最小载荷
                        z.setWell_common_name(well_id);
                    }
                }
            }
        }catch (Exception e){
//            System.out.println(resultStr);
        }
        bReader.close();
        is.close();
        return z;
    }
    @Override
    public synchronized void configure() throws Exception {

        /*JSONObject body = new JSONObject();

          restConfiguration()
                .component("servlet")
                .host("11.72.128.71");
        from("timer:mytimer?period=3600000")
                .setBody(simple(body.toJSONString()))
                .to("rest:post:/api-service/device/query?appKey=SR5vY4bED7&type=simple&pageSize=8000&page=1")
                .unmarshal().json(JsonLibrary.Jackson)
                .split(body()).process(
                exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    in.setHeader("id",aRow.get("data"));
                    in.setHeader("date", getDate());
                })
//                .setBody(simple("${header[data]}"))
//                .setBody(simple(body.toJSONString()))
                .setBody(simple("${in.header.id}"))
//                .log("${header.id}")
                .split(body()).process(
                exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
//                    loadDate(,aRow.get("id")+"/analyse/功图数据", );
//                    in.setHeader("id",aRow.get("id")+"/analyse/功图数据");
//                    in.setHeader("wellid",aRow.get("code"));
                    if (aRow.get("typeName").toString().indexOf("油井")> 0){
                        ZDJG_WELL zdjg_well = loadGtData(aRow.get("id")+"/analyse/功图数据", aRow.get("code").toString(), "2021-08-17");
                        aRow.put("sgt",gtTransUtil(zdjg_well.getZd_init_sgt()) );//null
                        aRow.put("susp_max_load",zdjg_well.getSxzh());//最大载荷
                        aRow.put("susp_min_load",zdjg_well.getXxzh());//最小载荷
                        aRow.put("stroke",zdjg_well.getStroke());
                        aRow.put("frequency",zdjg_well.getFrequence());
                        aRow.put("dyna_create_time",zdjg_well.getProd_date());
                        aRow.put("well_name",aRow.get("code"));
                    }


                })
                .log("${in.header.date}")
                .doTry()
                .setBody(simple("insert into centralbase.cb_temp_well_mech_runtime(well_id,prod_date,stroke_length,stroke_frequency,susp_max_load,susp_min_load,sgt) " +
                        "values( '${body[well_name]}','${in.header.date}','${body[stroke]}','${body[frequency]}','${body[susp_max_load]}','${body[susp_min_load]}','${body[sgt]}') " ))
//                        "where NOT EXISTS (SELECT * FROM centralbase.cb_temp_well_mech_runtime WHERE well_id = '${body[well_name]}' and  prod_date = '${in.header.date}' )"))
                .to("jdbc:centralbase")
                .doCatch(Exception.class)
                .end();*/

      /* JSONArray jsonArray = new JSONArray();
        JSONObject search = new JSONObject();
        JSONObject body = new JSONObject();
        body.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body.put("password", "Zdcycgtlyxt");
        body.put("filter", "1");
        body.put("pageNo", 1); // 页码，从1开始
        body.put("pageSize", 10);
        search.put("field", "父ID");
        search.put("rule", "=");
        search.put("val", "kvAfwAVEzv");
        jsonArray.add(search);
        body.put("search", jsonArray);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000 7天执行一次
        from("timer:mytimer?period=604800000")
                .setBody(simple(body.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body.toJSONString()))
                .to("rest:post:/dibs/0/service/S12967")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
        })
                .setBody(simple("insert into centralbase.cb_pc_organization(org_id,org_name,org_code,org_level,parent_id) values('${body[机构ID]}','${body[机构名称]}','${body[代码;机构代码]}','${body[级别]}','${body[父ID]}') " +
                        "ON conflict(org_id) DO UPDATE SET org_name= '${body[机构名称]}', org_code ='${body[代码;机构代码]}' ,org_level ='${body[级别]}' ,parent_id='${body[父ID]}' "))
                .to("jdbc:centralbase")
                .log("insert")
                .end();*/


       /* JSONObject body1 = new JSONObject();
        body1.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body1.put("password", "Zdcycgtlyxt");
        body1.put("filter", "1");
        body1.put("pageNo", 1); // 页码，从1开始
        body1.put("pageSize", 3100);
        restConfiguration() //
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=604800000")
                .setBody(simple(body1.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body1.toJSONString()))
                .to("rest:post:/dibs/0/service/S13048")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}")).log("${body}")
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("GEO_OFFSET_EAST") || !aRow.containsKey("GEO_OFFSET_NORTH") || !aRow.containsKey("P_START_PROD_STITUM")) {
                aRow.put("GEO_OFFSET_EAST", "0.0");
                aRow.put("GEO_OFFSET_NORTH", "0.0");
                aRow.put("P_START_PROD_STITUM", "0");
            }
        })
                .setBody(simple("insert into centralbase.cb_cd_well_source(well_id,well_common_name,well_legal_name,reason,well_purpose,p_start_prod_stitum,org_id,struct_id,oilfield_id,exp_area_id,group_unit_id,station_id,geo_offset_east,geo_offset_north,completion_id) " +
                        "values('${body[WELL_ID]}','${body[WELL_COMMON_NAME]}','${body[WELL_LEGAL_NAME]}','${body[REASON]}','${body[WELL_PURPOSE]}','${body[P_START_PROD_STITUM]}','${body[ORG_ID]}','${body[STRUCT_ID]}','${body[OILFIELD_ID]}','${body[EXP_AREA_ID]}','${body[GROUP_UNIT_ID]}','${body[STATION_ID]}','${body[GEO_OFFSET_EAST]}','${body[GEO_OFFSET_NORTH]}','${body[COMPLETION_WELL_ID]}')" +
                        "  ON conflict(well_id) DO UPDATE SET well_common_name= '${body[WELL_COMMON_NAME]}', well_legal_name ='${body[WELL_LEGAL_NAME]}' ,reason ='${body[REASON]}' ,well_purpose='${body[WELL_PURPOSE]}'," +
                        "p_start_prod_stitum ='${body[P_START_PROD_STITUM]}',org_id ='${body[ORG_ID]}',struct_id ='${body[STRUCT_ID]}',oilfield_id ='${body[OILFIELD_ID]}',exp_area_id ='${body[EXP_AREA_ID]}',group_unit_id ='${body[GROUP_UNIT_ID]}',station_id ='${body[STATION_ID]}',geo_offset_east ='${body[GEO_OFFSET_EAST]}',geo_offset_north ='${body[GEO_OFFSET_NORTH]}',completion_id='${body[COMPLETION_WELL_ID]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/


        /*JSONObject body2 = new JSONObject();
        body2.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body2.put("password", "Zdcycgtlyxt");
        body2.put("filter", "1");
        body2.put("pageNo", 1); // 页码，从1开始
        body2.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=604800000")
                .setBody(simple(body2.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body2.toJSONString()))
                .to("rest:post:/dibs/0/service/S13049")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("顶部垂深") || !aRow.containsKey("底部垂深") || !aRow.containsKey("生产层段名称") || !aRow.containsKey("生产层位ID") || !aRow.containsKey("是否是斜井")) {
                aRow.put("顶部垂深", "0.0");
                aRow.put("底部垂深", "0.0");
                aRow.put("生产层段名称", "0");
                aRow.put("生产层位ID", "0");
                aRow.put("是否是斜井", " ");
            }
        })
                .setBody(simple("insert into centralbase.cb_cd_well_source(well_id,completion_name,completion_id,top_tvd,bottom_tvd,is_deviated,spud_date) values('${body[井ID]}','${body[生产层段名称]}','${body[生产层位ID]}','${body[顶部垂深]}','${body[底部垂深]}','${body[是否是斜井]}','${body[投产日期]}')" +
                        " ON conflict(well_id) DO UPDATE SET completion_name= '${body[生产层段名称]}', completion_id ='${body[生产层位ID]}' ,top_tvd ='${body[顶部垂深]}' ,bottom_tvd='${body[底部垂深]}' ,is_deviated= '${body[是否是斜井]}',spud_date= '${body[投产日期]}' "))
                //.setBody(simple("update centralbase.cb_cd_well_source set completion_name = '${body[生产层段名称]}',completion_id= '${body[生产层位ID]}',top_tvd='${body[顶部垂深]}' ,bottom_tvd = '${body[底部垂深]}' where well_id='${body[井ID]}' "))
                .to("jdbc:centralbase")
                .log("insert")
                .end();*/


        /*JSONObject body3 = new JSONObject();
        body3.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body3.put("password", "Zdcycgtlyxt");
        body3.put("pageNo", 1); // 页码，从1开始
        body3.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000  一小时执行一次
        from("timer:mytimer?period=3600000")
                .setBody(simple(body3.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body3.toJSONString()))
                .to("rest:post:/dibs/0/service/S13051")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
        })
                .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,oil_prod_method) values('${body[井ID]}','${body[采油方式]}') " +
                        " ON conflict(well_id) DO UPDATE SET oil_prod_method= '${body[采油方式]}' "))
                .to("jdbc:centralbase")
                .end();*/


       /* JSONObject body4 = new JSONObject();
        body4.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body4.put("password", "Zdcycgtlyxt");
        body4.put("pageNo", 1); // 页码，从1开始
        body4.put("pageSize", 3200);
        restConfiguration().component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body4.toJSONString()))
                .log("${body}")
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body4.toJSONString()))
                .to("rest:post:/dibs/0/service/S13053")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("油嘴") || !aRow.containsKey("回压") || !aRow.containsKey("井口温度") || !aRow.containsKey("干线压力") || (!aRow.containsKey("最高油压")) || !aRow.containsKey("最低油压") || !aRow.containsKey("最高套压") || !aRow.containsKey("最低套压")) {
                aRow.put("油嘴", "0.0");
                aRow.put("回压", "0.0");
                aRow.put("井口温度", "0.0");
                aRow.put("干线压力", "0.0");
                aRow.put("最高油压", "0.0");
                aRow.put("最低油压", "0.0");
                aRow.put("最高套压", "0.0");
                aRow.put("最低套压", "0.0");
            }
            if (aRow.containsKey("最高油压") && aRow.containsKey("最低油压")) {
                if (aRow.get("最高油压").equals("0")) aRow.put("最高油压", "0.0");
                if (aRow.get("最低油压").equals("0")) aRow.put("最低油压", "0.0");
                Double upOli = Double.valueOf(aRow.get("最高油压").toString());
                Double downOli = Double.valueOf(aRow.get("最低油压").toString());
                aRow.put("平均油压", (upOli + downOli) / 2);
                if (!aRow.containsKey("平均油压")) aRow.put("平均油压", "0.0");
            }
            if (aRow.containsKey("最高套压") && aRow.containsKey("最低套压")) {
                if (aRow.get("最高套压").equals("0")) aRow.put("最高套压", "0.0");
                if (aRow.get("最低套压").equals("0")) aRow.put("最低套压", "0.0");
                Double upT = Double.valueOf(aRow.get("最高套压").toString());
                Double downT = Double.valueOf(aRow.get("最低套压").toString());
                aRow.put("平均套压", (upT + downT) / 2);
                if (!aRow.containsKey("平均套压")) aRow.put("平均套压", "0.0");
            }
        })
                .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,prod_date,oil_nozzle,back_pres,wh_temp,main_line_pres,avg_oil_pres,avg_casing_pres) " +
                        "values('${body[井ID]}','${body[日期]}','${body[油嘴]}','${body[回压]}','${body[井口温度]}','${body[干线压力]}','${body[平均油压]}','${body[平均套压]}')" +
                        "  ON conflict(well_id) DO UPDATE SET prod_date ='${body[日期]}', oil_nozzle ='${body[油嘴]}',back_pres='${body[回压]}' ,wh_temp='${body[井口温度]}',main_line_pres = '${body[干线压力]}',avg_oil_pres='${body[平均油压]}',avg_casing_pres='${body[平均套压]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/


       /* JSONObject body5 = new JSONObject();
        body5.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body5.put("password", "Zdcycgtlyxt");
        body5.put("pageNo", 1); // 页码，从1开始
        body5.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body5.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body5.toJSONString()))
                .to("rest:post:/dibs/0/service/S13054")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("泵深") || !aRow.containsKey("动液面") || !aRow.containsKey("静液面")) {
                aRow.put("泵深", "0.0");
                aRow.put("动液面", "0.0");
                aRow.put("静液面", "0.0");
            }
        })
                .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_status_daily(well_id,pump_depth,start_pump_liq_level,end_pump_liq_level) " +
                        "values('${body[井ID]}','${body[泵深]}','${body[动液面]}','${body[静液面]}')" +
                        "  ON conflict(well_id) DO UPDATE SET pump_depth= '${body[泵深]}',start_pump_liq_level= '${body[动液面]}', end_pump_liq_level='${body[静液面]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/

       /* JSONObject body6 = new JSONObject();
        body6.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body6.put("password", "Zdcycgtlyxt");
        body6.put("pageNo", 1); // 页码，从1开始
        body6.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body6.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body6.toJSONString()))
                .to("rest:post:/dibs/0/service/S13055")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("理论排量") || !aRow.containsKey("动液面") || !aRow.containsKey("静液面") || !aRow.containsKey("静压") || !aRow.containsKey("流压") || !aRow.containsKey("泵径") || !aRow.containsKey("泵深") || !aRow.containsKey("泵效") || !aRow.containsKey("转速") || !aRow.containsKey("冲程") || !aRow.containsKey("冲次") || !aRow.containsKey("悬点最大载荷") || !aRow.containsKey("悬点最小载荷") || !aRow.containsKey("螺杆泵铭牌排量") || !aRow.containsKey("代表流压梯度") || !aRow.containsKey("电机功率") || !aRow.containsKey("电流频率")) {
                aRow.put("理论排量", "0.0");
                aRow.put("动液面", "0.0");
                aRow.put("静液面", "0.0");
                aRow.put("静压", "0.0");
                aRow.put("流压", "0.0");
                aRow.put("泵径", "0.0");
                aRow.put("泵深", "0.0");
                aRow.put("泵效", "0.0");
                aRow.put("转速", "0.0");
                aRow.put("冲程", "0.0");
                aRow.put("冲次", "0.0");
                aRow.put("悬点最大载荷", "0.0");
                aRow.put("悬点最小载荷", "0.0");
                aRow.put("螺杆泵铭牌排量", "0.0");
                aRow.put("代表流压梯度", "0.0");
                aRow.put("电机功率", "0.0");
                aRow.put("电流频率", "0.0");
            }
        })
                .setBody(simple("insert into centralbase.cb_temp_well_mech_runtime(well_id,theo_discharge,indi_diagram_interp_code,dynamic_liq_level,static_liq_lev,static_pressure,flow_pres,pump_diameter,pump_depth,pump_efficiency,rotate_frequency,stroke_length,stroke_frequency,susp_max_load,susp_min_load,pump_tag_discharge,rep_pressure_gradient_flow,pump_type,electromotor_power,elec_frequency) " +
                        "values('${body[井ID]}','${body[理论排量]}','${body[示功图解释代码]}','${body[动液面]}','${body[静液面]}','${body[静压]}','${body[流压]}','${body[泵径]}','${body[泵深]}','${body[泵效]}','${body[转速]}','${body[冲程]}','${body[冲次]}','${body[悬点最大载荷]}','${body[悬点最小载荷]}','${body[螺杆泵铭牌排量]}','${body[代表流压梯度]}','${body[泵型]}','${body[电机功率]}','${body[电流频率]}') " +
                        " ON conflict(well_id) " +
                        "DO UPDATE SET theo_discharge ='${body[理论排量]}' ,indi_diagram_interp_code ='${body[示功图解释代码]}' ,dynamic_liq_level='${body[动液面]}'" +
                        ",static_liq_lev='${body[静液面]}',static_pressure='${body[静压]}',flow_pres='${body[流压]}',pump_diameter='${body[泵径]}',pump_depth='${body[泵深]}',pump_efficiency='${body[泵效]}',rotate_frequency='${body[转速]}',stroke_length='${body[冲程]}',stroke_frequency='${body[冲次]}',susp_max_load='${body[悬点最大载荷]}',susp_min_load='${body[悬点最小载荷]}',pump_tag_discharge='${body[螺杆泵铭牌排量]}',rep_pressure_gradient_flow='${body[代表流压梯度]}',pump_type='${body[泵型]}',electromotor_power='${body[电机功率]}',elec_frequency='${body[电流频率]}' "))
                .to("jdbc:centralbase")
                .log("insert!!!")
                .end();*/

        /*JSONObject body7 = new JSONObject();
        body7.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body7.put("password", "Zdcycgtlyxt");
        body7.put("pageNo", 1); // 页码，从1开始
        body7.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body7.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body7.toJSONString()))
                .to("rest:post:/dibs/0/service/S13056")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("气油比") || !aRow.containsKey("水气比")) {
                aRow.put("气油比", "0.0");
                aRow.put("水气比", "0.0");
            }
        })
                .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_vol_daily(well_id,gas_oil_ratio,water_gas_ratio) " +
                        "values('${body[井ID]}','${body[气油比]}','${body[水气比]}')" +
                        "  ON conflict(well_id) DO UPDATE SET gas_oil_ratio= '${body[气油比]}',water_gas_ratio= '${body[水气比]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/

       /* JSONObject body8 = new JSONObject();
        body8.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body8.put("password", "Zdcycgtlyxt");
        body8.put("pageNo", 1); // 页码，从1开始
        body8.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body8.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body8.toJSONString()))
                .to("rest:post:/dibs/0/service/S13057")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (!aRow.containsKey("生产时间") || !aRow.containsKey("水密度") || !aRow.containsKey("油密度") || !aRow.containsKey("日产液量") || !aRow.containsKey("日产油量") || !aRow.containsKey("日产水量") || !aRow.containsKey("日产气量") || !aRow.containsKey("含水率") || !aRow.containsKey("含砂率") || !aRow.containsKey("气体含硫物量") || !aRow.containsKey("气体含氯根量")) {
                aRow.put("生产时间", "0.0");
                aRow.put("水密度", "0.0");//水密度和油密度目前没有,所以写了一个默认的值
                aRow.put("油密度", "0.0");
                aRow.put("日产液量", "0.0");
                aRow.put("日产油量", "0.0");
                aRow.put("日产水量", "0.0");
                aRow.put("日产气量", "0.0");
                aRow.put("含水率", "0.0");
                aRow.put("含砂率", "0.0");
                aRow.put("气体含硫物量", "0.0");
                aRow.put("气体含氯根量", "0.0");
            }
        })
                .setBody(simple("insert into centralbase.cb_pc_pro_wellbore_vol_daily(well_id,stim_key_id,prod_date,prod_time,liq_prod_daily,oil_prod_daily,water_prod_daily,gas_prod_daily,water_cut,sand_content_ratio,gas_fluid_content,gas_chloride_content,remarks,surface_crude_water_density,surface_crude_oil_density) " +
                        "values('${body[井ID]}','${body[措施代码]}','${body[日期]}','${body[生产时间]}','${body[日产液量]}','${body[日产油量]}','${body[日产水量]}','${body[日产气量]}','${body[含水率]}','${body[含砂率]}','${body[气体含硫物量]}','${body[气体含氯根量]}','${body[备注]}','${body[水密度]}','${body[油密度]}')" +
                        "  ON conflict(well_id) DO UPDATE SET prod_date='${body[日期]}',stim_key_id='${body[措施代码]}',prod_time='${body[生产时间]}',liq_prod_daily='${body[日产液量]}',oil_prod_daily='${body[日产油量]}',water_prod_daily='${body[日产水量]}',gas_prod_daily='${body[日产气量]}',water_cut='${body[含水率]}',sand_content_ratio='${body[含砂率]}',gas_fluid_content='${body[气体含硫物量]}',gas_chloride_content='${body[气体含氯根量]}',remarks='${body[备注]}',surface_crude_water_density = '${body[水密度]}',surface_crude_oil_density ='${body[油密度]}'  "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/

       /* JSONObject body9 = new JSONObject();
        body9.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body9.put("password", "Zdcycgtlyxt");
        body9.put("pageNo", 1); // 页码，从1开始
        body9.put("pageSize", 3200);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?period=3600000")
                .setBody(simple(body9.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body9.toJSONString()))
                .to("rest:post:/dibs/0/service/S13044")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
        })
                .setBody(simple("update centralbase.cb_pc_pro_wellbore_vol_daily set stim_content = '${body[P_DESCRIPTION]}' where stim_key_id ='${body[CODE]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/


        //这个我们需要的表他们这里没有数据,用了完井信息的创建信息
       /* JSONObject body10 = new JSONObject();
        body10.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body10.put("password", "Zdcycgtlyxt");
        body10.put("pageNo", 1); // 页码，从1开始
        body10.put("pageSize", 5500);
        restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000 7天执行一次
        from("timer:mytimer?period=604800000")
                .setBody(simple(body10.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body10.toJSONString()))
                .to("rest:post:/dibs/0/service/S13058")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
            if (aRow.get("完井日期").equals("")) aRow.put("完井日期", "0000-00-00 00:00:00");
            if (aRow.containsKey("完井日期") && !aRow.get("完井日期").equals("") && aRow.get("完井日期") != null) {
                String inj_date = (String) aRow.get("完井日期");
                String[] s = inj_date.split(" ")[0].split("-");
                Integer injDate = Integer.valueOf(s[0] + s[1] + s[2]);
                aRow.put("完井日期", injDate);
            }
        })
                .setBody(simple("insert into centralbase.cb_pc_inj_well_status_daily(well_id,inj_date) values('${body[井ID]}','${body[完井日期]}') " +
                        " ON conflict(well_id) DO UPDATE SET inj_date= '${body[完井日期]}'"))
                .to("jdbc:centralbase")
                .log("insert!!!")
                .end();*/

















         /*
      现在这个有问题,查不到对应的id值
      JSONObject search1 = new JSONObject();
        JSONObject body5 = new JSONObject();
        body5.put("userno", "zdcycgtlyxt"); // 分配的系统用户账号
        body5.put("password", "Zdcycgtlyxt");
        body5.put("pageNo", 1); // 页码，从1开始
        body5.put("pageSize", 1500);
        body5.put("search",search1);
        search1.put("field","UPDATE_DATE");
        search1.put("rule",">=");
        search1.put("val","2021-06-08 00:00:00");
        search1.put("field","UPDATE_DATE");
        search1.put("rule","<=");
        search1.put("val","2021-06-09 00:00:00");
  restConfiguration()
                .component("servlet")
                .host("11.71.3.110")
                .port("30010");//timer:mytimer?period=2000
        from("timer:mytimer?repeatCount=1")
                .setBody(simple(body6.toJSONString()))
                .to("rest:post:/dibs/0/service/token")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setHeader("token", simple("${body[token]}"))
                .setHeader("Authorization", simple("Bearer " + "${in.header.token}"))
                .setBody(simple(body6.toJSONString()))
                .to("rest:post:/dibs/0/service/S11043")
                .unmarshal().json(JsonLibrary.Jackson)
                .setBody(simple("${body[result]}"))
                .setBody(simple("${body[page]}"))
                .setBody(simple("${body[records]}"))
                .split(body()).process(exchange -> {
            Message in = exchange.getIn();
            HashMap<String, Object> aRow = in.getBody(HashMap.class);
        })
                .setBody(simple("insert into centralbase.cb_cd_well_source(well_id,PRODUCING_AREA_name) " +
                        "values('${body[单元ID]}','${body[名称]}') " +
                        " ON conflict(well_id) DO UPDATE SET PRODUCING_AREA_name= '${body[名称]}' "))
                .to("jdbc:centralbase")
                .log("insert completed")
                .end();*/
    }


}